
include <library/box.scad>
include <MCAD-master/materials.scad>
$fn = 100;

module amplifer_box()
{
    //keyCubeFull(); 

}


    nl2_frontResses = 2.55; 
    nl2_frontDia = 23.6; 
    nl2_mountThick = 6; 
    nl2_mountHeight = 31; 
    nl2_mountWidth = 26;
    nl2_screwDia = 3.2;
    nl2_screwX = 19;
    nl2_screwY = 24;  
    nl2_bladeLen = 8; 
    nl2_bladeWidth = 5; 
    nl2_bladeThick = 1.5;
    nl2_backIsolationDepth=1.95;
    nl2_tubeDia = 24; 
    nl2_tubeDepth = 25.75 - nl2_mountThick - nl2_backIsolationDepth;
    nl2_bladeOneY = 4.5; 
    nl2_bladeTwox = 5.5;
    n12_bladeZ = nl2_tubeDepth + nl2_bladeLen/2;
    n12_firstHoleDia = 19;
    n12_fisrtHoleDepth = 24; 


neutrik_nl2();

module neutrik_nl2()
{
    neutrik_nl2_tube(); 
    color(BlackPaint)neutric_nl2_mount();
    color(Steel)translate([-nl2_bladeTwox,0,-n12_bladeZ])neutrik_nl2_blade();
    color(Steel)translate([0,nl2_bladeOneY,-n12_bladeZ])rotate([0,0,90])neutrik_nl2_blade();
}

module neutric_nl2_mount()
{
    difference()
    {
        translate([0,0,nl2_mountThick/2])keyCubeRounded(nl2_mountWidth,nl2_mountHeight,nl2_mountThick,3,true);
        translate([-(nl2_screwX/2),(nl2_screwY/2),-0.01])cylinder(d=nl2_screwDia, h=nl2_mountThick+0.02);
        translate([(nl2_screwX/2),-(nl2_screwY/2),-0.01])cylinder(d=nl2_screwDia, h=nl2_mountThick+0.02);
    }
}

module neutrik_nl2_tube()
{   
    difference() 
    {
        union()
        {
            translate([0,0,nl2_mountThick])cylinder(d=nl2_frontDia,h=nl2_frontResses);
            translate([0,0,-nl2_tubeDepth])cylinder(d=nl2_tubeDia,h=nl2_tubeDepth);
        }
        translate([0,0,nl2_mountThick])cylinder(d=n12_firstHoleDia,h=n12_fisrtHoleDepth);
    }
}


module neutrik_nl2_blade()
{
       cube(size = [nl2_bladeThick,nl2_bladeWidth,nl2_bladeLen], center = true);
}